EnableExplicit
If OpenConsole() = 0
  MessageRequester("OpenConsole() error","Unable to open the console.",0)
  End
EndIf
Define i.l
Global str.s
For i = 1 To 19
  str = str + Chr(205)
Next
ConsoleTitle ("img2prime")
EnableGraphicalConsole(1)
PrintN(Chr(201)+str+Chr(187))
PrintN(Chr(186)+" img2prime - deeph "+Chr(186))
PrintN(Chr(200)+str+Chr(188))
PrintN("")
Define p.l
If CountProgramParameters() = 0
  PrintN("Error : no input.")
  Input()
  End
EndIf
For p = 0 To CountProgramParameters()-1
  Define file.s = ProgramParameter()
  If GetExtensionPart(file) = "jpg" Or GetExtensionPart(file) = "jpeg"
    UseJPEG2000ImageDecoder()
  ElseIf GetExtensionPart(file) = "png"
    UsePNGImageDecoder()
  ElseIf GetExtensionPart(file) = "tif"
    UseTIFFImageDecoder()
  ElseIf GetExtensionPart(file) = "tga"
    UseTGAImageDecoder()
  ElseIf GetExtensionPart(file) <> "bmp"
    PrintN("Error : image format unsupported.")
    Input()
    End
  EndIf
  If LoadImage(0, file)
    If CreateFile(0, GetPathPart(ProgramFilename())+ReplaceString(GetFilePart(file), GetExtensionPart(file), "txt"))
      Define y.l, x.l, s.s
      CreateImage(1, ImageHeight(0)*ImageWidth(0), 1, 32)
      If StartDrawing(ImageOutput(1))
        DrawingMode(#PB_2DDrawing_AllChannels)
        For y = 0 To ImageHeight(0)
          GrabImage(0, 2, 0, y, ImageWidth(0), 1)
          DrawAlphaImage(ImageID(2), y*ImageWidth(0), 0)
        Next
        WriteString(0, "{#")
        For x = 0 To ImageWidth(1)-1 Step 4
          i = 3
          If x+i > ImageWidth(1)-1
            i = ImageWidth(1)-1-x
          EndIf
          y = x+i
          s = ""
          For i = i To 0 Step -1
            s+UCase(RSet(Hex(Bool(Alpha(Point(x+i, 0)) = 0)<<15+Red(Point(x+i, 0))>>3<<10+Green(Point(x+i, 0))>>3<<5+Blue(Point(x+i, 0))>>3), 4, "0"))
          Next i
          LTrim(s, "0")
          If s = ""
            s = "0"
          EndIf
          WriteString(0, s)
          WriteString(0, ":64")
          If y <> ImageWidth(1)-1
            WriteString(0, ",#")
          EndIf
        Next x
        WriteString(0, "}")
        StopDrawing()
      EndIf
      PrintN(ReplaceString(GetFilePart(file), GetExtensionPart(file), "txt")+" correctly generated.")
      CloseFile(0)
    Else
      PrintN("Error : unable to create the output file.")
    EndIf
  Else
    PrintN("Error : unable to open the image.")
  EndIf
Next p
Input()
End
; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 58
; FirstLine = 44
; EnableXP
; EnableUser
; Executable = img2prime.exe
; CommandLine = "sprite.png"
; EnablePurifier